<?php
$_SERVER['SERVER_PORT'] = 80;
$_SERVER['SERVER_NAME'] = 'Linnworks_net';
define('CC_IN_ADMIN', false);
date_default_timezone_set("UTC");
set_time_limit(600); // 10 Mins max

require_once("../../../../ini.inc.php");
require_once("../../../../includes/global.inc.php");

define('ADMIN_CP', false);
require_once("../../../../includes/functions.inc.php");



$GLOBALS['cache'] = Cache::getInstance();
$GLOBALS['db'] = Database::getInstance($glob);
$GLOBALS['config'] = Config::getInstance($glob);
$GLOBALS['config']->merge('config', '', $config_default);
$GLOBALS['debug'] = Debug::getInstance();
$GLOBALS['session'] = Session::getInstance();
$GLOBALS['smarty'] = new Smarty();
$GLOBALS['smarty']->muteExpectedErrors();
$GLOBALS['smarty']->error_reporting = E_ALL & ~E_NOTICE & ~E_WARNING;
$GLOBALS['smarty']->compile_dir  = CC_SKIN_CACHE_DIR;
$GLOBALS['smarty']->config_dir   = CC_SKIN_CACHE_DIR;
$GLOBALS['smarty']->cache_dir    = CC_SKIN_CACHE_DIR;
$GLOBALS['smarty']->debugging = false;
$GLOBALS['language'] = Language::getInstance();
$GLOBALS['hooks'] = HookLoader::getInstance();
$GLOBALS['seo'] = SEO::getInstance();
$GLOBALS['gui'] = GUI::getInstance();

$GLOBALS['db']->query("DROP TABLE " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp", false, 0, false);
$GLOBALS['db']->query("CREATE TABLE " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp LIKE " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_catalogue", false, 0, false);

// Get our INVENTORY
$sql = "
        INSERT INTO
          " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp
        SELECT
            1,
            i.product_id,
            NULL,
            0.00
        FROM
            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_inventory i
        ORDER BY
            i.product_id                
    ";
$GLOBALS['db']->query($sql, false, 0, false);


// Get a distinct list of products that have matrix data
$sql = "
        SELECT
            om.product_id,
            i.price,
            i.sale_price,
            i.name
        FROM
            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_matrix om
        JOIN
            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_inventory i
                ON
                    om.product_id = i.product_id
        WHERE
            om.status = 1
        GROUP BY
            om.product_id    
        ORDER BY
            om.product_id,
            i.name
    ";
$matrix_products = $GLOBALS['db']->query($sql, false, 0, false);

if(isset($matrix_products) && is_array($matrix_products) && !empty($matrix_products)){
    foreach($matrix_products as $matrix_product){

        // Option prices CAN be impacted by global sales mode in the store settings. We need to check for this condition and may need to reduce the base price of the option
        if($GLOBALS['config']->get('config', 'catalogue_sale_mode') == 2 && $GLOBALS['config']->get('config', 'catalogue_sale_percentage') > 0){

            // Adjust the option price by the global percentage discount value
            $product_base_price = $matrix_product['price'] - round((($matrix_product['price'] / 100) * $GLOBALS['config']->get('config', 'catalogue_sale_percentage')), 2);

        }else if($GLOBALS['config']->get('config', 'catalogue_sale_mode') == 1 && $matrix_product['sale_price'] > 0 && $matrix_product['sale_price'] < $matrix_product['price']){
            // What about per item sale price?
            $product_base_price = $matrix_product['sale_price'];

        }else{
            $product_base_price = $matrix_product['price'];
        }

        // Get our unique option groups for this product_id
        $sql = "
                SELECT
                    a.set_name,
                    a.option_id
                FROM
                    (
                        SELECT
                            CAST(os.set_name AS CHAR) as set_name,
                            ov.value_name,
                            oa.option_negative,
                            oa.option_price,
                            oa.option_id,
                            oa.value_id
                        FROM
                            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set_product osp
                        JOIN
                            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set os
                                ON osp.set_id = os.set_id
                        JOIN
                            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set_member sm
                                ON osp.set_id = sm.set_id
                        JOIN
                            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_value ov
                                ON sm.value_id = ov.value_id
                        LEFT JOIN
                            " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_assign oa
                                ON oa.set_enabled = 1
                                AND oa.set_member_id != 0
                                AND osp.product_id = oa.product
                                AND sm.value_id = oa.value_id
                                AND sm.set_member_id = oa.set_member_id
                        WHERE
                            osp.product_id = " . $matrix_product['product_id'] . "

                        UNION
                            SELECT
                                CAST(og.option_name AS CHAR) as set_name,
                                ov.value_name,
                                oa.option_negative,
                                oa.option_price,
                                oa.option_id,
                                oa.value_id
                            FROM
                                " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_assign oa
                            JOIN
                                " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_group og
                                    ON oa.option_id = og.option_id
                            JOIN
                                " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_value ov
                                    ON oa.value_id = ov.value_id
                            WHERE
                                oa.set_enabled = 1
                                AND oa.set_member_id = 0
                                AND oa.product = " . $matrix_product['product_id'] . "
                    ) a
                GROUP BY
                    a.set_name,
                    a.option_id    
                ORDER BY
                    a.option_id
            ";
        $product_option_names = $GLOBALS['db']->query($sql, false, 0, false);

        // Declare the start of our dynamically built query and loop counter
        $loop_counter = 1;
        $dynamic_query1 = "SELECT ";
        $dynamic_query_select = "";
        $dynamic_query_from = "";

        if(isset($product_option_names) && is_array($product_option_names) && !empty($product_option_names)){

            $total_option_type_records = count($product_option_names);

            foreach($product_option_names as $option_name){

                $set_name = $option_name['set_name'];

                $dynamic_query_select .= ($loop_counter == 1 ? null : " ,") . "a" . $loop_counter . ".set_name AS 'a" . $loop_counter . ".set_name' , a" . $loop_counter . ".value_name AS 'a" . $loop_counter . ".value_name', a" . $loop_counter . ".option_negative AS 'a" . $loop_counter . ".option_negative', a" . $loop_counter . ".option_price AS 'a" . $loop_counter . ".option_price'";
                $dynamic_query_select .= ", a" . $loop_counter . ".option_id AS 'a" . $loop_counter . ".option_id', a" . $loop_counter . ".value_id AS 'a" . $loop_counter . ".value_id'";

                $dynamic_query_from .= ($loop_counter == 1 ? null : ",") . " ( 
                                                SELECT 
                                                    CAST(os.set_name AS CHAR) as set_name, 
                                                    ov.value_name, 
                                                    oa.option_negative, 
                                                    oa.option_price,
                                                    oa.option_id AS option_id, 
                                                    oa.value_id AS value_id
                                                FROM 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set_product osp 
                                                JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set os 
                                                        ON 
                                                            osp.set_id = os.set_id 
                                                            AND 
                                                            os.set_name = '$set_name' 
                                                JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_options_set_member sm
                                                        ON 
                                                            osp.set_id = sm.set_id 
                                                JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_value ov 
                                                        ON 
                                                            sm.value_id = ov.value_id 
                                                LEFT JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_assign oa 
                                                        ON 
                                                            oa.set_enabled = 1 
                                                            AND 
                                                            oa.set_member_id != 0 
                                                            AND 
                                                            osp.product_id = oa.product 
                                                            AND 
                                                            sm.value_id = oa.value_id 
                                                            AND 
                                                            sm.set_member_id = oa.set_member_id
                                                LEFT JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_matrix om 
                                                        ON 
                                                            md5(CONCAT(oa.option_id, oa.value_id)) = om.options_identifier 
                                                            AND 
                                                            oa.product = om.product_id
                                                WHERE 
                                                    osp.product_id = " . $matrix_product['product_id'] . "
                                                
                                                UNION 
                                                
                                                SELECT 
                                                    CAST(og.option_name AS CHAR) as set_name, 
                                                    ov.value_name, 
                                                    oa.option_negative, 
                                                    oa.option_price,
                                                    og.option_id, ov.value_id
                                                FROM 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_assign oa 
                                                JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_group og 
                                                        ON 
                                                            oa.option_id = og.option_id 
                                                            AND 
                                                            og.option_name = '$set_name' 
                                                JOIN 
                                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_value ov 
                                                        ON 
                                                            oa.value_id = ov.value_id 
                                                WHERE 
                                                    oa.set_enabled = 1 
                                                    AND 
                                                    oa.set_member_id = 0 
                                                    AND 
                                                    oa.product = " . $matrix_product['product_id'] . " 
                                                ) a" . $loop_counter;
                $loop_counter++;

            } // end foreach $product_option_names

            // Build and run our final SQL query
            // Build & Run the query
            $dynamic_matrix_query = $GLOBALS['db']->query($dynamic_query1 . $dynamic_query_select . " FROM " . $dynamic_query_from, false, 0, false);

            if(isset($dynamic_matrix_query) && is_array($dynamic_matrix_query) && !empty($dynamic_matrix_query)){
                foreach($dynamic_matrix_query as $product_option){
                    // Reset our loop counter for navigating fields
                    $loop_counter = 1;
                    $matrix_string = ""; // Reset Variable
                    $matrix_sku = ""; // Reset out SKU to an empty string. We will check if it is still empty later
                    $matrix_sku_price = $product_base_price;


                    // Here we loop through all our column names to get the values for this array
                    while($loop_counter <= $total_option_type_records+1){

                        // Get variables for this combination!
                        $child_set_name = "a" . $loop_counter . ".set_name";
                        $child_set_name = $product_option[$child_set_name];

                        $child_value_name = "a" . $loop_counter . ".value_name";
                        $child_value_name = $product_option[$child_value_name];

                        $child_value_negative = "a" . $loop_counter . ".option_negative";
                        $child_value_negative = $product_option[$child_value_negative];

                        $child_value_price = "a" . $loop_counter . ".option_price";
                        $child_value_price = $product_option[$child_value_price];

                        $child_option_id = "a" . $loop_counter . ".option_id";
                        $child_option_id = $product_option[$child_option_id];

                        $child_value_id = "a" . $loop_counter . ".value_id";
                        $child_value_id = $product_option[$child_value_id];

                        $loop_counter++;

                        // be safe in case something is b0rked move to the next loop attempt
                        if(empty($child_set_name) || empty($child_value_name)){
                            continue;
                        }

                        // Check if our value is empty, totally possible. Replace with 0 if it is.
                        if($child_value_price == ""){
                            $child_value_price = 0;
                        }

                        // the CubeCart default behaviour is to only adjust the product base price, then add or subtract the option price
                        // However, there is an exception. Global price discounts also apply to options.
                        // Per product sale mode prices only apply to the base price
                        // Calculate the option price based on this

                        if($child_value_price > 0){
                            // Option prices CAN be impacted by global sales mode in the store settings. We need to check for this condition and may need to reduce the base price of the option
                            // no other sale mode will impact the option price.
                            if($GLOBALS['config']->get('config', 'catalogue_sale_mode') == 2 && $GLOBALS['config']->get('config', 'catalogue_sale_percentage') > 0){
                                // Adjust the option price by the global percentage discount value
                                $child_value_price = $child_value_price - round((($child_value_price / 100) * $GLOBALS['config']->get('config', 'catalogue_sale_percentage')),2);
                            }
                        }

                        if($child_value_negative == 1){
                            $matrix_sku_price+- $child_value_price;
                        }else{
                            // Adjust the price accordingly
                            $matrix_sku_price+=  $child_value_price;
                        }

                        $matrix_string .= $child_option_id . $child_value_id;

                    }   // End looping our dynamically added columns

                    // We have a valid string of matrix stuff
                    if($matrix_string != ""){

                        // We have a matrix defined, so lets build the MD5 key
                        $matrix_id = md5($matrix_string);

                        // Select the record from our table
                        // Check the matrix hash exists
                        $matrix_hash_sql = "
                                SELECT
                                    matrix_id,
                                    cached_name
                                FROM
                                    " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_option_matrix
                                WHERE
                                    options_identifier = '". $matrix_id . "'
                                    AND
                                    status = 1
                                    AND 
                                    product_id = " . $matrix_product['product_id'];
                        $matrix_hash_query = $GLOBALS['db']->query($matrix_hash_sql, false, 0, false);      // no cache

                        if(isset($matrix_hash_query) && is_array($matrix_hash_query) && !empty($matrix_hash_query)){

                            $sql = "
                                INSERT INTO
                                  " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp
                                VALUES
                                    (
                                        2,
                                        " . $matrix_hash_query[0]['matrix_id'] . ",
                                        '" . $matrix_product['name'] . ", " . strip_tags($matrix_hash_query[0]['cached_name']) . "',
                                        " . $matrix_sku_price . "
                                    )  
                            ";
                            $GLOBALS['db']->query($sql, false, 0, false);

                        }   // end if $matrix_hash_query

                    }   // End if $matrix_string has content

                }   // End foreach $dynamic_matrix_query

            }   // End if exists $dynamic_matrix_query

        } // if exists $product_option_names

    } // end foreach $matrix_products

} // If exists $matrix_products

$GLOBALS['db']->query("TRUNCATE TABLE " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_catalogue",  false, 0, false);

$sql = "
    INSERT INTO
          " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_catalogue
    SELECT
        *
    FROM
        " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp
";
$GLOBALS['db']->query($sql, false, 0, false);

$GLOBALS['db']->query("DROP TABLE " . $GLOBALS['config']->get('config', 'dbprefix') . "CubeCart_linnworks_temp",  false, 0, false);
