<div id="Linnworks_net" class="tab_content">
    <form action="{$VAL_SELF}" method="post" enctype="multipart/form-data">
        <h3>{$LANG.linnworks_net.module_title}</h3>

        <fieldset><legend>{$LANG.linnworks_net.config_settings}</legend>
            <div><label for="module_version">{$LANG.linnworks_net.module_version}</label><span>{$MODULE_VERSION}</span></div>
            <div><label for="status">{$LANG.common.status}</label><span><input type="hidden" name="module[status]" id="status" class="toggle" value="{$MODULE.status}" />&nbsp;</span></div>
            <div><label for="status">{$LANG.linnworks_net.generate_api_key}</label><span><input type="submit" name="new_api_key" id="new_api_key" class="button small" value="{$LANG.linnworks_net.generate}" />&nbsp;</span></div>
            <div><label for="apiKey">{$LANG.linnworks_net.api_key}</label><span><textarea id="api_key" readonly style="width:50%;" name="module[api_key]">{$API_KEY}</textarea></span></div>
            <div><label for="orderStatus1">{$LANG.linnworks_net.orderStatus1}</label><span><input type="hidden" name="module[orderStatus1]" id="orderStatus1" class="toggle" value="{$MODULE.orderStatus1}" />&nbsp;</span></div>
            <div><label for="orderStatus3">{$LANG.linnworks_net.orderStatus3}</label><span><input type="hidden" name="module[orderStatus3]" id="orderStatus3" class="toggle" value="{$MODULE.orderStatus3}" />&nbsp;</span></div>
            <div><label for="data_terms">{$LANG.linnworks_net.data_terms}</label><span><input type="hidden" name="module[data_terms]" id="data_terms" class="toggle" value="{$MODULE.data_terms}" />&nbsp;</span></span></div>
        </fieldset>

        <fieldset>
            <legend>{$LANG.linnworks_net.catalogue_status}</legend>
            <div><label for="estimated_inventory">{$LANG.linnworks_net.estimated_inventory}</label><span>{$ESTIMATED_INVENTORY_ITEMS}</span></div>
            <div><label for="estimated_matrix">{$LANG.linnworks_net.estimated_matrix}</label><span>{$ESTIMATED_MATRIX_ITEMS}</span></div>
            <div><label for="estimated_total">{$LANG.linnworks_net.estimated_total}</label><span>{$ESTIMATED_TOTAL_ITEMS}</span></div>
            <div><label for="current_cat_total">{$LANG.linnworks_net.current_cat_total}</label><span>{$CURRENT_CATALOGUE_TOTAL}</span></div>
        </fieldset>

        <div class="form_control">
            <input type="submit" value="{$LANG.common.save}" />
        </div>
        <input type="hidden" name="token" value="{$SESSION_TOKEN}" />

        <fieldset><legend>{$LANG.linnworks_net.user_guide}</legend>
            <div>
                <p><b>Overview</b><br/>The Linnworks channel is made up of two elements.
                <ol>
                    <li>You will require a Linnworks account and have the CubeCart channel added to your account via the Linnworks app store</li>
                    <li>you require this module to be installed, configured and enabled. You must also accept the data transfer agreement, which is outlined in detail below</li>
                </ol>

                When you install the CubeCart channel within Linnworks you will be prompted for your API key. You can change your API key at any time by editing the channel within Linnworks.
                </p>
            </div>

            <div>
                <p><b>Supported Features</b>
                <ul>
                    <li>Import inventory from CubeCart to Linnworks</li>
                    <li>Import orders from CubeCart to Linnworks
                        <ul>
                            <li>To prevent sending of orders in a Pending status to Linnworks, enable the &quot;<i>{$LANG.linnworks_net.orderStatus1}</i>&quot; setting</li>
                            <li>To prevent sending of orders in an Order Complete status to Linnworks, enable the &quot;<i>{$LANG.linnworks_net.orderStatus3}</i>&quot; setting</li>
                        </ul>
                    </li>
                    <li>Update and Complete orders in CubeCart based on processing the order in Linnworks</li>
                    <li>Update CubeCart stock levels with those on Linnworks</li>
                    <li>Import Payment modules from CubeCart into Linnworks</li>
                    <li>Import Shipping modules from CubeCart into Linnworks</li>
                </ul>
                </p>
            </div>

            <div>
                <p><b>Requirements</b><br>This module has the following requirements
                    <ul>
                        <li>PHP 7.1 or higher</li>
                        <li>IonCube loaders installed for PHP. <i>Note: most hosting providers have these installed. If you are unsure about this item, please contact support.</i></li>
                        <li>A secure connection to your website (HTTPS)</li>
                        <li>Every product and product option has a unique product code</li>
                        <li>All product options must be added to the options matrix</li>
                        <li>CubeCart 6.2.3 or later - Contact support if you wish to use an earlier version of CubeCart</li>
                        <li>If you apply tax rules, ensure all of your inventory prices are configured excluding tax</li>
                        <li>Setup and schedule a process to run (cron job), see notes below.</li>
                    </ul>
                </p>
            </div>

            <div>
                <p><b>Limitations</b><br>
                <ol>
                    <li>Do not use fixed price discount promotional codes. It is not possible to import orders that use fixed price discounts into Linnworks. CubeCart applies fixed price discounts against the order total, where as Linnworks applies fixed price discounts at the line item level. It is not possible to work around this and keep financial information accurate.</li>
                    <li>It is not possible to update the price of products with options in CubeCart, based on adjustments in Linnworks. CubeCart sets a price for the base product which then is adjusted based upon selected options, where as in Linnworks each variation has a stand alone price. If you require matrix items to be revised based on changes in Linnworks please open a support ticket, there may be a solution for you by using the <a href="https://www.noodleman.co.uk/cubecart-absolute-prices-for-product-matrix-options.html">Absolute Matrix Option Prices plugin.</a></li>
                    <li>Orders placed on your store before this module was installed, configured and enabled will not import correctly into Linnworks. This is by design as this module captures extra information required by Linnworks at the time orders are placed.</li>
                </ol>
                </p>
            </div>

            <div>
                <p>
                    <b>Data logging and transfer</b><br>
                    The Linnworks platform has been designed for retailers on cloud based platforms, such as Ebay or Amazon. In order for Linnworks to be able to communicate with your store all traffic sent from Linnworks to your store, and from your store to Linnworks is relayed via a middleware server at www.noodleman.co.uk.</p>

                <p>
                    The middleware server does store some data for support purposes only. The following data is recorded:
                    <ol>
                        <li>Every request from Linnworks to your store, specifically
                            <ol>
                                <li>The date and time of the request</li>
                                <li>The type of request (For example, requesting new orders)</li>
                                <li>The payload of the request in JSON format. you can view what this data contains from the Linnworks documentation found <a href="https://apps.linnworks.net/resources/extensions">here</a></li>
                                <li>Authorization Token, a unique identifier for your channel integration</li>
                                <li>The URL within your store to which the request will be relayed</li>
                            </ol>
                        </li>
                        <li>
                            Requests from linnworks to your store are archived for a maximum of 28 days after which they are permanently deleted
                        </li>
                        <li>
                            No data sent from your store to Linnworks is stored on the relay server.
                        </li>
                        <li>
                            Deleting the CubeCart channel from Linnworks will trigger an automated deletion of all data stored on the middleware server
                        </li>
                        <li>
                            Requests from Linnworks and replies from your store to Linnworks will only be processed if the &quot;<i>{$LANG.linnworks_net.data_terms}</i>&quot; setting has been enabled. Enabling this setting confirms you agree with data being used over a relay and stored as described in this section.
                        </li>
                    </ol>
                </p>
            </div>

            <div>
                <p><b>Cron Job</b><br>
                    This module requires that you setup a scheduled job to run at least once every 24 hours. The scheduled job pre-processes your inventory into a simplified format which speeds up the sending of data to Linnworks. The cron job populates the Linnworks Product Catalogue.
                </p>
                <ol>
                    <li>Setup a scheduled job in your web site hosting control panel, the path to the file to call is <i>{$CRON_FILE_PATH}</i></li>
                    <li>Schedule the job to run at least once every 24 hours, You can run this more frequently if required. perhaps every 1-2 hours.</li>
                    <li>If you are unsure how to setup a cron job or want assistance with this step please contact support</li>
                </ol>
                </p>
            </div>

        </fieldset>
    </form>
</div>
